C  CONTROL BLOCK FOR THE DEVICE-DEPENDENT AREA EXTENSION FOR THE
C  SINGLE VALUED RASTER PSEUDO-DEVICE.
      SAVE          /UGPS00/
C  MAXIMUM NUMBER OF WORDS PER SCAN LINE.
      INTEGER       DDXZ1
      PARAMETER     (DDXZ1=64)
C  NUMBER OF WORDS IN ONE BAND OF SCAN LINES.
      INTEGER       DDXZ2
      PARAMETER     (DDXZ2=2048)
C  CONTROL BLOCK LENGTH.
      INTEGER       DDXZZ
      PARAMETER     (DDXZZ=2137)
C  THE DECLARATION OF THE COMMON BLOCK.
      COMMON        /UGPS00/
     X              DDXID,
     X              DDXB1,DDXP3,DDXP5,
     X              DDXNS,DDXGL,DDXSS,
     X              DDXMU,DDXLN,DDXSN,
     X              DDXBD,DDXPL,
     X              DDXEC,
     X              DDXBB,DDXTB,
     X              DDXPP,DDXPC,
     X              DDXPW,DDXLW,
     X              DDXLS,DDXPV,DDXDC,
     X              DDXIO
C  DEVICE-DEPENDENT AREA EXTENSION IDENTIFICATION.
      CHARACTER*8   DDXID
C  POINTER TO SUBROUTINE UGB001.
      INTEGER       DDXB1
C  POINTER TO SUBROUTINE UGPS03.
      INTEGER       DDXP3
C  POINTER TO SUBROUTINE UGPS05.
      INTEGER       DDXP5
C  SIZE OF SAVE BLOCKS FOR ACCUMULATING A COMPLETE PICTURE.
      INTEGER       DDXNS
C  GENERATE INTENSITY LEVEL FLAG:
C    0 MEANS DO NOT GENERATE INTENSITY WITH LINE WIDTH, AND
C    1 MEANS GENERATE INTENSITY WITH LINE WIDTH.
      INTEGER       DDXGL
C  STARTING SIDE FOR RASTER SCAN GENERATION.
      INTEGER       DDXSS
C  MAXIMUM USED RASTER UNIT IN THE FORWARD DIRECTION.
      INTEGER       DDXMU
C  NUMBER OF FULL WORDS PER SCAN LINE.
      INTEGER       DDXLN
C  NUMBER OF SCAN LINES PER BAND.
      INTEGER       DDXSN
C  ONE BAND OF SCAN LINES.
      INTEGER*4     DDXBD(DDXZ2)
C  PREVIOUS SCAN LINE.
      INTEGER*4     DDXPL(DDXZ1)
C  EQUAL LINE COUNT.
      INTEGER       DDXEC
C  BEGINNING LINE NUMBER IN THE CURRENT BAND OF SCAN LINES.
      INTEGER       DDXBB
C  TERMINAL LINE NUMBER IN THE CURRENT BAND OF SCAN LINES.
      INTEGER       DDXTB
C  POINTER TO THE PRIMARY SAVE BLOCK.
      INTEGER       DDXPP
C  POINTER TO THE CURRENT SAVE BLOCK.
      INTEGER       DDXPC
C  ACTUAL POINT WIDTH.
      INTEGER       DDXPW
C  ACTUAL LINE WIDTH.
      INTEGER       DDXLW
C  LINE SEGMENT COORDINATES.
      INTEGER       DDXLS(4)
C  PICTURE AVAILABLE FLAG:
C    0 MEANS NO PREVIOUS PICTURE IS AVAILABLE, AND
C    1 MEANS A PICTURE HAS PREVIOUSLY BEEN PRODUCED.
      INTEGER       DDXPV
C  DEFERRED CLEAR FLAG:
C    0 MEANS THE START OF A NEW PICTURE HAS NOT BEEN DEFERRED, AND
C    1 MEANS THE START OF A NEW PICTURE HAS BEEN DEFERRED.
      INTEGER       DDXDC
C  INPUT/OUTPUT IDENTIFICATION VALUE.
      INTEGER       DDXIO
C  THE FOLLOWING ARRAY OVERLAYS THE ENTIRE DDA EXTENSION.
      INTEGER       DDXRY(DDXZZ)
      EQUIVALENCE   (DDXRY(1),DDXID)
